/* backl.c     v0.1  (C) 1999 adolfo@di-mare.com */


#include "backl.h"
#include <mem.h>
#include <alloc.h>

void init_backward(list_backward *I) {
    memcpy(I->mark, "Init", 12);
    I->vmt.bind     = bind_backward;
    I->vmt.finished = finished_backward;
    I->vmt.here     = here_backward;
    I->vmt.next     = next_backward;
    I->vmt.done     = done_backward;

    I->L = NULL;
    I->v = NULL;
}

void bind_backward( iterator(list) *I_vmt , list *L) {
    list_backward *I = vmt_self(list_backward, I_vmt);
    memcpy(I->mark, "bind", 12);

    if (NULL != I->v) {
       free(I->v);
    }

    I->index = 0;
    I->count = list_count(L);
    if (0 == I->count) {
        I->v = NULL;
        return;
    }

    I->L = L;
    I->v = (lpos *) malloc(I->count * sizeof(lpos));
    {   int  i = I->count;
        lpos p = list_first(L);
        while (i>0) {
            i--;
            I->v[i] = p;
            p = list_next(L, p);
        }
    }

}

int finished_backward( iterator(list) *I_vmt ) {
    list_backward *I = vmt_self(list_backward, I_vmt);
    memcpy(I->mark, "finished", 12);

    return (NULL == I->v);
}

lpos here_backward( iterator(list) *I_vmt ) {
    list_backward *I = vmt_self(list_backward, I_vmt);
    memcpy(I->mark, "here", 12);

    return I->v[I->index];
}

void next_backward( iterator(list) *I_vmt ) {
    list_backward *I = vmt_self(list_backward, I_vmt);
    memcpy(I->mark,  "next", 12);

    I->index++;
    if (I->index >= I->count) {
       free(I->v);
       I->v = NULL;
    }
}

void done_backward( iterator(list) *I_vmt ) {
    list_backward *I = vmt_self(list_backward, I_vmt);
    memcpy(I->mark,  "done", 12);

    if (NULL != I->v) {
       free(I->v);
    }
}

/* EOF: backl.c */
