/* iterator.h  v0.1  (C) 1999 adolfo@di-mare.com */

#ifndef   ITERATOR_H
#define   ITERATOR_H

#include <stddef.h>  /* offsetof() */

#ifdef __cplusplus
extern "C" {
#endif

#define define_itr_vmt(CONTAINER, CPos) \
typedef struct itr_ ## CONTAINER ## _vmt_ {               \
                                                          \
  void (*bind)     (struct itr_ ## CONTAINER ## _vmt_ *, CONTAINER*);\
  int  (*finished) (struct itr_ ## CONTAINER ## _vmt_ *); \
  CPos (*here)     (struct itr_ ## CONTAINER ## _vmt_ *); \
  void (*next)     (struct itr_ ## CONTAINER ## _vmt_ *); \
  void (*done)     (struct itr_ ## CONTAINER ## _vmt_ *); \
} itr_ ## CONTAINER ## _vmt

#define itr_vmt(CONTAINER) \
    itr_ ## CONTAINER ## _vmt vmt

#define iterator(CONTAINER) \
    itr_ ## CONTAINER ## _vmt

#define itr_bind(itr, container) \
    (itr).vmt.bind(&((itr).vmt), &(container))

#define itr(I, method)  ((I).vmt.method(& ((I).vmt) ))

typedef struct {
    char v[ (sizeof(char)==1 ? 1 : 0) ];
} check_that_size_of_char_is_one_;

#define vmt_self(ITR_TYPE, ITR) \
           ((ITR_TYPE *) (((char *)ITR) - offsetof(ITR_TYPE, vmt)))
/*                         +----+ */
/* This requires sizeof(char) == 1 */

typedef struct iterator_vmt_  {
    void   (*bind)     (struct iterator_vmt_ *, void *);
    int    (*finished) (struct iterator_vmt_ *);
    void * (*here)     (struct iterator_vmt_ *);
    void   (*next)     (struct iterator_vmt_ *);
    void   (*done)     (struct iterator_vmt_ *);
} iterator_vmt;

#ifdef __cplusplus
}
#endif

#endif /* ITERATOR_H */
/* EOF:   iterator.h */
