/* list.h      v0.1  (C) 1999 adolfo@di-mare.com */

#ifndef   LIST_H
#define   LIST_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stddef.h>

typedef struct { char nada; } *lpos;

typedef struct {
    lpos   _first;       /* private */
    size_t _node_size;   /* private */
} list, *plist;

#define list_init(L, VTYPE)       \
   list_init_(&L, sizeof(VTYPE))

void    list_done(list *);
size_t  list_count(list *L);
void    list_insert(list *, lpos, void*);

#define list_append(L, val) \
          list_insert(L, list_last(L), val)

#define list_first(L)  ((L)->_first)
lpos    list_last(list *L);
#define list_next(L,p) ((lpos) (((list_node*)p)->next))

/* convert to (void) pointer to stored value */
#define list_retrieve(L,p) \
          ((void*) & ((list_node*) p)->val)

/* Non-macro versions of inlined code */
void   list_init_     (list *, size_t);
void   list_append_   (list *, void*);
lpos   list_first_    (list *);
lpos   list_next_     (list *, lpos);
void * list_retrieve_ (list *, lpos p);

typedef struct list_node_ {
    struct list_node_ * next; /* private */
    char                val;  /* private */
} list_node;

#ifdef __cplusplus
}
#endif

#endif /* LIST_H */
/* EOF:   list.h */
