/* order.h     v0.0  (C) 1999 adolfo@di-mare.com */

/* Traverse a list in order, from the smaller
   to the bigger elements */

#ifndef   ORDER_H
#define   ORDER_H

#ifdef __cplusplus
extern "C" {
#endif

#include "list.h"
#include "iterator.h"

#ifndef iterator_list_
    define_itr_vmt(list, lpos);
    #define iterator_list_
#endif

typedef struct list_order_ {
    char  mark[12];
    itr_vmt(list);
    list * L;
    lpos * v;
    size_t index, count;
    int (*fcmp)(const void *, const void *);
} list_order;

void init_order(list_order *,
   int (*fcmp)(const void *, const void *));

void bind_order(     iterator(list) *I , list *L);
int  finished_order( iterator(list) *I );
lpos here_order(     iterator(list) *I );
void next_order(     iterator(list) *I );
void done_order(     iterator(list) *I );

#ifdef __cplusplus
}
#endif

#endif /* ORDER_H */
/* EOF:   order.h */
